package aop.example;

import org.aspectj.lang.*;
import javax.servlet.http.*;

/**
 *   
 * @author Zubairov Renat
 */
public aspect AuditAspect {

	/**
	 *       
	 *         
	 */
	public pointcut controllerMethods(HttpServletRequest request) :
		//       HttpServletRequest  HttpServletResponse
		//     HttpServlet
		execution(* javax.servlet.http.HttpServlet+.*(HttpServletRequest, HttpServletResponse)) && args(request, HttpServletResponse);


	/**
	 * Advice      
	 *       
	 *    
	 */
	before(HttpServletRequest request) : controllerMethods(request) {
		//      
		Signature sig = thisJoinPointStaticPart.getSignature();
		//   
		System.out.println("User " + 
			request.getSession().getAttribute(EntranceFilter.USER_KEY).toString() + 
			" executing " + sig.getDeclaringType().getName() + 
			"." + sig.getName());
	}

}
