package aop.example;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import aop.example.model.AlbumList;
import aop.example.model.AnonymousUser;
import aop.example.model.Album;
import aop.example.model.User;

/**
 *   / 
 * @author Zubairov Renat
 */
public class ViewServlet extends HttpServlet {

	/**
	 * Empty constructor 
	 */
	public ViewServlet() {
		super();
	}
	
	/**
	 *  / 
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		//   ,    
		AnonymousUser currentUser = (AnonymousUser) req.getSession().getAttribute(EntranceFilter.USER_KEY);
		//      
		//       
		AlbumList albums = (AlbumList)req.getSession().getAttribute("albums"); 
		//  
		if (req.getParameter("delete") != null) {
			//  List.remove(Object)  
			// ..    equals(Object)   Album
			albums.deleteAlbum( albums.getAlbumByTitle(req.getParameter("delete")));
		}
		//  
		if ((req.getParameter("newAlbum") != null) && (currentUser instanceof User)) {
			//   
			albums.addAlbum(new Album((User)currentUser, req.getParameter("newAlbum").toString()));
		}
		// H view.vm
		getServletContext().getRequestDispatcher("view.vm").forward(req, resp);
	}

}
